# Ion.Range Slider 1.8.2

> <a href="readme.md">English description</a> | Описание на русском

Удобный легкий слайдер диапазонов. <a href="http://ionden.com/a/plugins/ion.rangeSlider/">Страница проекта и демо</a>

Скачать: <a href="http://ionden.com/a/plugins/ion.rangeSlider/ion.rangeSlider-1.8.2.zip">ion.rangeSlider-1.8.2.zip</a>

***

## Описание
Ion.RangeSlider — красивый, удобный и легко настраиваемый слайдер диапазонов, поддерживающий скины. Слайдер поддерживает события, имеет гибкие настройки, может быть полностью видоизменен через CSS.<br />
Слайдер поддерживает отрицательные и дробные значения<br />
Слайдер поддерживает устройства с touch-экраном (iPhone, iPad, etc.).<br />
Слайдер свободно распространяется на условиях <a href="http://ionden.com/a/plugins/licence.html" target="_blank">лицензии MIT</a>.

## Зависимости
* <a href="http://jquery.com/" target="_blank">jQuery 1.9+</a>


## Использование

Подключаем библиотеки:
* jQuery
* ion.rangeSlider.min.js

Подключаем стили:
* normalize.min.css (желательно, если он у вас еще не подключен)
* ion.rangeSlider.css

Не забываем про скин. 2 скина включены в архив:
* ion.rangeSlider.skinNice.css
* ion.rangeSlider.skinSimple.css

Не забудьте подключить картинку-спрайт скина:
* sprite-skin-simple.png - простецкий скин
* sprite-skin-nice.png - приличный скин
Либо воспользуйтесь вложенным в архив PSD файлом, и нарисуйте собственный скин (не забудьте модифицировать размеры элементов в CSS файле)


## Инициализация

Создаем базовое поле <code>input type="text"</code>, оно может содержать минимальные значения по умолчанию (<code>{min}</code> и <code>{max}</code>):
```html
<input type="text" id="someID" name="rangeName" value="10;100" />
```

Чтобы запустить слайдер, вызовите ionRangeSlider для нужного элемента:
```javascript
$("#someID").ionRangeSlider();
```

## Настройка

<table class="options">
    <thead>
        <tr>
            <th>Атрибут</th>
            <th>По умолчанию</th>
            <th>Описание</th>
        </tr>
    </thead>
    <tbody>
        <tr>
            <td>type</td>
            <td>"single"</td>
            <td>Не обязательный параметр, позволяет выбрать тип слайдера, может принимать значение <code>single</code> - для одиночного слайдера или <code>double</code> - для двойного слайдера</td>
        </tr>
        <tr>
            <td>min</td>
            <td>10</td>
            <td>Не обязательный параметр, автоматически устанавливается из атрибута <code>value</code> базового поля input. Например если value="10;100", то примет значение 10</td>
        </tr>
        <tr>
            <td>max</td>
            <td>100</td>
            <td>Не обязательный параметр, автоматически устанавливается из атрибута <code>value</code> базового поля input. Например если value="10;100", то примет значение 100</td>
        </tr>
        <tr>
            <td>from</td>
            <td>min</td>
            <td>Не обязательный параметр, по умолчанию равен значению min. Позволяет задать стартовую позицию слайдера "ОТ"</td>
        </tr>
        <tr>
            <td>to</td>
            <td>max</td>
            <td>Не обязательный параметр, по умолчанию равен значению max. Позволяет задать стартовую позицию слайдера "ДО"</td>
        </tr>
        <tr>
            <td>step</td>
            <td>1</td>
            <td>Не обязательный параметр, задает шаг слайдера</td>
        </tr>
        <tr>
            <td>postfix</td>
            <td>-</td>
            <td>Не обязательный параметр, добавляет текст после всех значений. Например postfix - " грамм" модифицирует значение "100" в "100 грамм"</td>
        </tr>
        <tr>
            <td>hasGrid</td>
            <td>false</td>
            <td>Не обязательный параметр, включает сетку ниже слайдера (высота увеличивается на 20px и это можно настроить через CSS)</td>
        </tr>
        <tr>
            <td>hideMinMax</td>
            <td>false</td>
            <td>Не обязательный параметр, отключает поля Min и Max</td>
        </tr>
        <tr>
            <td>hideFromTo</td>
            <td>false</td>
            <td>Не обязательный параметр, отключает поля From и To</td>
        </tr>
        <tr>
            <td>prettify</td>
            <td>true</td>
            <td>Не обязательный параметр, позволяет разделять длинные цифры пробелами, например 10 000 вместо 10000</td>
        </tr>
    </tbody>
</table>


## Колбэки

<table class="options">
    <thead>
        <tr>
            <th>Атрибут</th>
            <th>По умолчанию</th>
            <th>Описание</th>
        </tr>
    </thead>
    <tbody>
        <tr>
            <td>onLoad</td>
            <td>-</td>
            <td>Функция обратного вызова, вызывается один раз при инициализации слайдера или после обновления через метод Update</td>
        </tr>
        <tr>
            <td>onChange</td>
            <td>-</td>
            <td>Callback функция, вызывается каждый раз при смене состояния слайдера, возвращает объект, содержащий параметры слайдера</td>
        </tr>
        <tr>
            <td>onFinish</td>
            <td>-</td>
            <td>Callback функция, вызывается один раз при смене состояния слайдера, когда работа слайдера завершена. Возвращает объект, содержащий параметры слайдера</td>
        </tr>
    </tbody>
</table>


Пример слайдера, запущенного с параметрами:
```javascript
$("#someID").ionRangeSlider({
    min: 10,                        // минимальное значение
    max: 100,                       // максимальное значение
    from: 30,                       // предустановленное значение ОТ
    to: 80,                         // предустановленное значение ДО
    type: "single",                 // тип слайдера
    step: 10,                       // шаг слайдера
    postfix: " грамм",              // постфикс значение
    hasGrid: true,                  // показать сетку
    hideMinMax: true,               // спрятать поля Min и Max
    hideFromTo: true,               // спрятать поля From и To
    prettify: true,                 // разделять цифры пробелами 10 000
    onChange: function(obj){        // callback функция, вызывается при изменении состояния
        console.log(obj);
    },
    onFinish: function(obj){        // callback функция, вызывается один раз по окончании использования слайдера
        console.log(obj);
    }
});
```

Слайдер с параметрами можно также инициализировать используя атрибуты <code>data-*</code> у тэга <code>input</code>:
```html
data-from="30"                      // предустановленное значение ОТ
data-to="70"                        // предустановленное значение ДО
data-type="double"                  // тип слайдера
data-step="10"                      // шаг слайдера
data-postfix=" грамм"               // постфикс значение
data-hasgrid="true"                 // показать сетку
data-hideminmax="true"              // спрятать поля Min и Max
data-hidefromto="true"              // спрятать поля From и To
data-prettify="false"               // не разделять цифры пробелами 10000 вместо 10 000
```

## Публичные методы

Обновление слайдера, метод <code>update</code>:
```javascript
$("#someID").ionRangeSlider("update", {
    min: 20,                        // меняем минимальное значение
    max: 90,                        // меняем максимальное значение
    from: 40,                       // меняем предустановленное значение ОТ
    to: 70,                         // меняем предустановленное значение ДО
    step: 5                         // меняем шаг слайдера
});
```

Удаление слайдера, метод <code>remove</code>:
```javascript
$("#someID").ionRangeSlider("remove");
```

## История обновлений
* 31.10.2013 - Исправлены баги: # 13, 31, 35, 37, 40, несколько мелких оптимизаций кода
* 10.10.2013 - Новый скин Flat UI. Общие оптимизации скинов. Исправлен баг #25.
* 08.10.2013 - Исправлены задачи #20, #21, #23, #24, #26. Удален параметр hideText. Новый метод и настройки. Несколько мелких оптимизаций и улучшено оформление кода.
* 11.09.2013 - Исправлен баг в браузерах на Android-устройствах. Добавлена поддержка отрицательных и дробных чисел. Issues #15, 16
* 23.08.2013 - Исправлено несколько багов и добавлены новые возможности. Так же исправлены Issues #7-10
* 30.06.2013 - исправление мелких багов, новый параметр hideText
* 21.06.2013 - добавлена возможность показывать сетку
* 21.06.2013 - исправление мелких багов
* 06.06.2013 - добавлены публичные методы и произведена оптимизация кода
* 06.06.2013 - мелкие обновления CSS файлов
* 30.04.2013 - добавлен новый метод onFinish
* 15.02.2013 - добавлена возможность настраивать слайдер через атрибуты data-*